/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MAXROOT = 320;
const int MAXSIZE = 320;
const int MAXLOG = 17;
const int INF  = 1e9;

int n, m, q;
int cntBig;
int big[MAXN];
bool isInBasket[MAXN];
llong ans[MAXROOT][MAXN];
std::vector <int> basket[MAXN];
std::vector <int> in[MAXN];

void buildBig(int idx)
{
    big[idx] = ++cntBig;
    for (const int &b : in[idx])
    {
        for (const int &val : basket[b])
        {
            ans[big[idx]][val] += b;
        }
    }
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        if (in[i].size() >= MAXSIZE)
        {
            buildBig(i);
        }
    }

    std::cin >> q;
    for (int i = 1 ; i <= q ; ++i)
    {
        int a, b;
        std::cin >> a >> b;
        assert(a != b);

        if (in[a].size() < in[b].size())
        {
            std::swap(a, b);
        }

        if (big[a])
        {
            std::cout << ans[big[a]][b] << '\n';
        } else
        {
            llong ans = 0;
            for (const int &idx : in[a]) isInBasket[idx] = 1;
            for (const int &idx : in[b]) if (isInBasket[idx]) ans += idx;
            for (const int &idx : in[a]) isInBasket[idx] = 0;
            std::cout << ans << '\n';
        }
    }
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        int sz; std::cin >> sz;
        basket[i].resize(sz);
        for (int j = 0 ; j < sz ; ++j)
        {
            std::cin >> basket[i][j];
            in[basket[i][j]].push_back(i);
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}