/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <bitset>
#include <map>

typedef long long llong;
const int MAXN = 10000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n, k;
struct Info
{
    int x, y;
    int mask;

    inline bool cmp(int x) const
    {
        return (mask & (1 << x));
    }
};

std::vector <Info> info;
std::map <std::pair <int,int>, int> map;

int query(int x, int y)
{
    // std::cout << "query"
    if (map.count({x, y}))
    {
        return map[{x, y}];
    }

    int mask = 0;
    int mask2 = 0;
    std::vector <bool> res = compare(x, y);
    for (int i = k - 1 ; i >= 0 ; --i)
    {
        mask <<= 1;
        mask2 <<= 1;
        mask += res[i];
        mask2 += 1 ^ res[i];
    }

    map[{x, y}] = mask;
    map[{y, x}] = mask2;
    return mask;
}

int run;
int cmp(int x, int y)
{
    if (x == -1) return y;
    if (y == -1) return x;
    if (query(x, y) & (1 << run)) return x;
    return y;
}

std::mt19937 rng(57657);
std::vector <int> order;
std::vector <int> invOrder;
struct SegmentTree
{
    int tree[4 * MAXN];
    void build(int l, int r, int node)
    {
        if (l == r)
        {
            tree[node] = order[l];
            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node);
        build(mid + 1, r, 2*node + 1);
        tree[node] = cmp(tree[2*node], tree[2*node + 1]);
    }
    
    void update(int l, int r, int node, int queryPos)
    {
        if (l == r)
        {
            tree[node] = -1;
            return;
        }
        
        int mid = l + r >> 1;
        if (((r - l + 1) & 1) && rng() % 2 == 0)
        {
            mid++;
        }
        
        if (queryPos <= mid) update(l, mid, 2*node, queryPos);
        else update(mid + 1, r, 2*node + 1, queryPos);
        tree[node] = cmp(tree[2*node], tree[2*node + 1]);
    }
};

SegmentTree tree;
std::vector <std::vector <int>> pointSort(int N, int K)
{
    map.clear();
    n = N; k = K;
    std::vector <std::vector <int>> ans;
    std::vector <std::vector <int>> sol;
    ans.resize(k);
    order.clear();
    invOrder.clear();
    order.resize(n);
    invOrder.resize(n);
    std::iota(order.begin(), order.end(), 0);
    std::shuffle(order.begin(), order.end(), rng);

    for (int i = 0 ; i < n ; ++i)
    {
        invOrder[order[i]] = i;
    }

    for (int i = 0 ; i < k ; ++i)
    {
        run = i;
        tree.build(0, n - 1, 1);
        for (int j = 0 ; j < n ; ++j)
        {
            ans[i].push_back(tree.tree[1]);
            tree.update(0, n - 1, 1, invOrder[tree.tree[1]]);
        }
    }

    sol.resize(n);
    for (int i = 0 ; i < n ; ++i)
    {
        sol[i].resize(k);
    }

    for (int i = 0 ; i < k ; ++i)
    {
        for (int j = 0 ; j < n ; ++j)
        {
            sol[ans[i][j]][i] = j;
        }
    }
    
    return sol;
}

/*
15 
*/