/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <bitset>
#include <map>

typedef long long llong;
const int MAXN = 10000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n, k;
struct Info
{
    int x, y;
    int mask;

    inline bool cmp(int x) const
    {
        return (mask & (1 << x));
    }
};

std::vector <Info> info;

int query(int x, int y)
{
    int mask = 0;
    std::vector <bool> res = compare(x, y);
    for (int i = k - 1 ; i >= 0 ; --i)
    {
        mask <<= 1;
        mask += res[i];
    }

    return mask;
}

std::mt19937 rng(69420);
std::bitset <MAXN> bs[MAXN];
std::bitset <MAXN> know[MAXN];

void rec(std::vector <int> &nums, int run)
{
    if (nums.size() <= 1)
    {
        return;
    }

    std::shuffle(nums.begin(), nums.end(), rng);
    std::bitset <MAXN> curr;
    for (const int &val : nums)
    {
        curr[val] = 1;
    }

    for (const int &val : nums)
    {
        know[val] &= curr;
    }

    int max = 0;
    for (int i = 1 ; i < nums.size() ; ++i)
    {
        if (know[nums[i]].count() > know[nums[max]].count())
        {
            max = i;
        }
    }

    int pivot = nums[max];
    std::vector <int> left;
    std::vector <int> right;

    for (int i = 0 ; i < nums.size() ; ++i)
    {
        if (nums[i] == pivot)
        {
            continue;
        }

        if (know[pivot][nums[i]])
        {
            if (bs[nums[i]][pivot])
            {
                left.push_back(nums[i]);
            } else
            {
                right.push_back(nums[i]);
            }
        } else
        {
            int res = query(nums[i], pivot);
            info.push_back({nums[i], pivot, res});

            if (res & (1 << run))
            {
                left.push_back(nums[i]);
            } else
            {
                right.push_back(nums[i]);
            }
        }
    }

    rec(left, run);
    rec(right, run);
    int ptr = 0;

    for (const int &val : left) nums[ptr++] = val;
    nums[ptr++] = pivot;
    for (const int &val : right) nums[ptr++] = val;
}

std::vector <std::vector <int>> pointSort(int N, int K)
{
    n = N; k = K;
    std::vector <std::vector <int>> ans;
    std::vector <std::vector <int>> sol;
    info.clear();
    ans.resize(k);
    for (int i = 0 ; i < k ; ++i)
    {
        ans[i].resize(n);
        std::iota(ans[i].begin(), ans[i].end(), 0);
        for (int i = 0 ; i < n ; ++i)
        {
            know[i].reset();
            bs[i].reset();
        }

        for (const Info &curr : info)
        {
            know[curr.x][curr.y] = 1;
            bs[curr.x][curr.y] = ((curr.mask & (1 << i)) > 0);
            know[curr.y][curr.x] = 1;
            bs[curr.y][curr.x] = ((curr.mask & (1 << i)) == 0);
        }

        rec(ans[i], i);
    }

    sol.resize(n);
    for (int i = 0 ; i < n ; ++i)
    {
        sol[i].resize(k);
    }

    for (int i = 0 ; i < k ; ++i)
    {
        for (int j = 0 ; j < n ; ++j)
        {
            sol[ans[i][j]][i] = j;
        }
    }
    
    return sol;
}