/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <map>

typedef long long llong;
const int MAXN = 10000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n, k;
struct Info
{
    int x, y;
    int mask;

    inline bool cmp(int x) const
    {
        return (mask & (1 << x));
    }
};

int query(int x, int y)
{
    int mask = 0;
    std::vector <bool> res = compare(x, y);
    for (int i = k - 1 ; i >= 0 ; --i)
    {
        mask <<= 1;
        mask += res[i];
    }

    return mask;
}

int dep[MAXN];
bool hasParent[MAXN];
std::vector <int> g[MAXN];
std::vector <Info> info;
std::mt19937 rng(69420);

std::vector <std::vector <int>> pointSort(int N, int K)
{
    n = N; k = K;
    info.clear();
    std::vector <std::vector <int>> ans;
    std::vector <std::vector <int>> sol;
    ans.resize(k);

    for (int run = 0 ; run < k ; ++run)
    {
        std::fill(dep, dep + n, 1);
        for (int i = 0 ; i < n ; ++i)
        {
            g[i].clear();
        }

        ans[run].resize(n);
        std::fill(hasParent, hasParent + n, false);
        for (const auto &curr : info)
        {
            if (!hasParent[curr.x] && !hasParent[curr.y])
            {
                if (curr.cmp(run))
                {
                    dep[curr.x] = std::max(dep[curr.x], dep[curr.y] + 1);
                    g[curr.x].push_back(curr.y);
                    hasParent[curr.y] = true;
                } else
                {
                    dep[curr.x] = std::max(dep[curr.y], dep[curr.x] + 1);
                    g[curr.y].push_back(curr.x);
                    hasParent[curr.x] = true;
                }
            }
        }

        std::vector <int> heads;
        for (int i = 0 ; i < n ; ++i)
        {
            if (!hasParent[i])
            {
                heads.push_back(i);
            }
        }
    
        int ptr = 0;
        while (ptr < n)
        {
            assert(heads.size());
            if (heads.size() == 1)
            {
                ans[run][ptr] = heads[0];
                int root = heads[0];
                heads.pop_back();
                for (const int &u : g[root])
                {
                    heads.push_back(u);
                }

                ptr++;
                continue;
            }
        

            int idxOne = 0;
            int idxTwo = 1;

            for (int i = 2 ; i < heads.size() ; ++i)
            {
                if (dep[heads[i]] < dep[heads[idxOne]] || (dep[heads[i]] == dep[heads[idxOne]] && rng() % 2))
                {
                    idxTwo = idxOne;
                    idxOne = i;
                } else if (dep[heads[i]] < dep[heads[idxTwo]] || (dep[heads[i]] == dep[heads[idxTwo]] && rng() % 2))
                {
                    idxTwo = i;
                }
            }

            int curr = query(heads[idxOne], heads[idxTwo]);
            info.push_back({heads[idxOne], heads[idxTwo], curr});
            if (info.back().cmp(run))
            {
                dep[heads[idxOne]] = std::max(dep[heads[idxOne]], 1 + dep[heads[idxTwo]]);
                g[heads[idxOne]].push_back(heads[idxTwo]);
                std::swap(heads.back(), heads[idxTwo]);
                heads.pop_back();
            } else
            {
                dep[heads[idxTwo]] = std::max(1 + dep[heads[idxOne]], dep[heads[idxTwo]]);
                g[heads[idxTwo]].push_back(heads[idxOne]);
                std::swap(heads.back(), heads[idxOne]);
                heads.pop_back();
            }
        }
    }

    sol.resize(n);
    for (int i = 0 ; i < n ; ++i)
    {
        sol[i].resize(k);
    }

    for (int i = 0 ; i < k ; ++i)
    {
        for (int j = 0 ; j < n ; ++j)
        {
            sol[ans[i][j]][i] = j;
        }
    }

    return sol;
}