#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAXN = 2e5 + 10;
const ll INF = 1e18;

int n, a[MAXN], b[MAXN];

struct Node
{
    ll need, bottleneck, give;
    bool fict;

    Node(ll _need = 0, ll _bottleneck = INF, ll _give = 0, bool _fict = false)
    {
        need = _need;
        bottleneck = _bottleneck;
        give = _give;
        fict = _fict;
    }
};

Node merge_nodes(Node lf, Node rf)
{
    if (lf.fict == true)
        return rf;
    if (rf.fict == true)
        return lf;

    Node mf;

    if (lf.give + lf.bottleneck < rf.need)
    {
        mf.need = INF;
        mf.bottleneck = 0;
        mf.give = 0;
        return mf;
    }

    int pass_right = min(rf.bottleneck, lf.give);
    mf.give = rf.give + pass_right;
    mf.bottleneck = min(lf.bottleneck, rf.bottleneck - pass_right);
    mf.need = lf.need + max((ll)0, (rf.need - lf.give));

    return mf;
}

Node tree[4 * MAXN];
void build(int root, int left, int right)
{
    if (left == right)
    {
        if (a[left] <= b[left])
        {
            tree[root].give = b[left] - a[left];
            tree[root].bottleneck = a[left];
            tree[root].need = 0;
        }
        else
        {
            tree[root].need = a[left] - b[left];
            tree[root].bottleneck = b[left];
            tree[root].give = 0;
        }
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}

Node query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return  Node(0, 0, 0, true);

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return merge_nodes(query(root * 2, left, mid, qleft, qright),
                       query(root * 2 + 1, mid + 1, right, qleft, qright));
}

int to[MAXN], cover[MAXN];

void find_far()
{
    for (int i = 0; i < n; i ++)
    {
        int lb = i - 1, rb = n;
        while(lb + 1 < rb)
        {
            int mb = (lb + rb) / 2;
            Node cur = query(1, 0, n - 1, i, mb);
            if (cur.need == 0)
                lb = mb;
            else
                rb = mb;
        }
        to[i] = lb;
    }
}

const int MAXLOG = 20;
int lg[MAXN];
int dp[MAXLOG][MAXN];
void build_sparse_table()
{
    for (int i = 1; i <= n; i ++)
        lg[i] = lg[i / 2] + 1;

    for (int i = 0; i < n; i ++)
    {

        dp[0][i] = i;
    }

    for (int j = 1; j < lg[n]; j ++)
    {
        for (int i = 0; i <= n - (1 << j); i ++)
        {
            dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
            if (to[dp[j - 1][i]] >= to[dp[j][i]])
            {
                dp[j][i] = dp[j - 1][i];
            }
        }
    }

    /**cout << "--------------" << endl;
    for (int i = 0; i < n; i ++)
        cout << to[i] << " ";
    cout << endl;
    for (int j = 0; j < lg[n]; j ++, cout << endl)
        for (int i = 0; i < n; i ++)
        cout << dp[j][i] << " ";
    cout << "--------------" << endl;*/
}

int ask_max(int l, int r)
{

    int len = lg[r - l + 1] - 1;
    int res = dp[len][r - (1 << len) + 1];
    //cout << "ask " << l << " " << r << " " << dp[len][l] <<  " :: " << dp[len][r - (1 << len) + 1] << endl;
    //cout << len << endl;
    if (to[dp[len][l]] >= to[res])
        res = dp[len][l];
    return res;
}
void init(vector < int > kids, vector < int > candies)
{
    n = kids.size();
    for (int i = 0; i < n; i ++)
    {
        a[i] = kids[i];
        b[i] = candies[i];
    }

    build(1, 0, n - 1);
    find_far();
    build_sparse_table();
}

bool isValid(int l, int r)
{
    return false;
    int pivot = ask_max(l, r);
    /**for (int i = l; i <= r; i ++)
    {
        if (to[i] > to[pivot] || (to[i] == to[pivot] && i < pivot))
        {
            //cout << pivot <<  " " << to[pivot] << " " << i << " " << to[i] << endl;
            assert(false);
        }
    }*/
    Node trail;

    if (to[pivot] < r)
        return false;

    trail = query(1, 0, n - 1, pivot, r);

    if (pivot == l)
        return true;
    Node also = query(1, 0, n - 1, l, pivot - 1);
    if (also.need <= trail.give)
        return true;

    return false;
}

void update(int l, int r, int x, int y)
{
    assert(false);
    for (int i = l; i <= r; i ++)
    {
        a[i] = x;
        b[i] = y;
    }
    build(1, 0, n - 1);
    find_far();
    build_sparse_table();
}
