#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAXN = 2e5 + 10;
const ll INF = 1e18;

int n, a[MAXN], b[MAXN];

struct Node
{
    ll need, bottleneck, give;
    bool fict;

    Node(ll _need = 0, ll _bottleneck = INF, ll _give = 0, bool _fict = false)
    {
        need = _need;
        bottleneck = _bottleneck;
        give = _give;
        fict = _fict;
    }
};

Node merge_nodes(Node lf, Node rf)
{
    if (lf.fict == true)
        return rf;
    if (rf.fict == true)
        return lf;

    Node mf;

    if (lf.give + lf.bottleneck < rf.need)
    {
        mf.need = INF;
        mf.bottleneck = 0;
        mf.give = 0;
        return mf;
    }

    int pass_right = min(rf.bottleneck, min(rf.need, lf.give));
    mf.give = rf.give + pass_right;
    mf.bottleneck = min(lf.bottleneck, rf.bottleneck - pass_right);
    mf.need = lf.need + (rf.need - lf.give);

    return mf;
}

Node tree[4 * MAXN];
void build(int root, int left, int right)
{
    if (left == right)
    {
        if (a[left] <= b[left])
        {
            tree[root].give = b[left] - a[left];
            tree[root].bottleneck = a[left];
            tree[root].need = 0;
        }
        else
        {
            tree[root].need = a[left] - b[left];
            tree[root].bottleneck = b[left];
            tree[root].give = 0;
        }
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}

Node query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return  Node(0, 0, 0, true);

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return merge_nodes(query(root * 2, left, mid, qleft, qright),
                       query(root * 2 + 1, mid + 1, right, qleft, qright));
}
void init(vector < int > kids, vector < int > candies)
{
    n = kids.size();
    for (int i = 0; i < n; i ++)
    {
        a[i] = kids[i];
        b[i] = candies[i];
    }

    build(1, 0, n - 1);
}

bool isValid(int l, int r)
{
    int pivot = -1;
    Node trail;
    for (int i = l; i <= r; i ++)
    {
        Node cur = query(1, 0, n - 1, i, r);
        if (cur.need == 0)
        {
            pivot = i;
            trail = cur;
            break;
        }
    };


    if (pivot == -1)
        return false;

    Node also = query(1, 0, n - 1, l, pivot - 1);
    if (also.need <= trail.give)
        return true;

    return false;
}

void update(int l, int r, int x, int y)
{
    for (int i = l; i <= r; i ++)
    {
        a[i] = x;
        b[i] = y;
    }
    build(1, 0, n - 1);
}
