#include<iostream>
#include<vector>
using namespace std;
const long long INF=(1LL<<60);
const int MAX_N=2e5+4;
struct V
{
    long long maxpref;
    long long minpref;
    long long need;
    long long cap;
};
V tree[4*MAX_N];
long long lazycap[4*MAX_N];
long long lazyneed[4*MAX_N];
bool have[4*MAX_N];
void push_lazy(int node,long long l,long long r)
{
    if(!have[node])return;
    tree[node].minpref=min(lazycap[node]-lazyneed[node],(r-l+1)*(lazycap[node]-lazyneed[node]));
    tree[node].maxpref=max(-lazyneed[node],(r-l)*(lazycap[node]-lazyneed[node])-lazyneed[node]);
    tree[node].need=(r-l+1)*lazyneed[node];
    tree[node].cap=(r-l+1)*lazycap[node];
    if(l!=r)
    {
        lazyneed[2*node]=lazyneed[node];
        lazyneed[2*node+1]=lazyneed[node];
        have[2*node+1]=1;

        lazycap[2*node]=lazycap[node];
        lazycap[2*node+1]=lazycap[node];
        have[2*node]=1;
    }
    have[node]=0;
}
void pullup(V&node,V L,V R)
{
    if(L.cap==-1){node=R;return;}
    if(R.cap==-1){node=L;return;}
    node.need=L.need+R.need;
    node.cap=L.cap+R.cap;
    node.maxpref=max(L.cap-L.need+R.maxpref,L.maxpref);
    node.minpref=min(L.cap-L.need+R.minpref,L.minpref);
}
void Update(int node,int l,int r,int ql,int qr,int ncap,int nneed)
{
    push_lazy(node,l,r);
    if(l>qr or r<ql)return;
    if(ql<=l && r<=qr)
    {
        have[node]=1;
        lazycap[node]=ncap;
        lazyneed[node]=nneed;
        push_lazy(node,l,r);
        return;
    }
    int mid=(l+r)/2;
    Update(2*node,l,mid,ql,qr,ncap,nneed);
    Update(2*node+1,mid+1,r,ql,qr,ncap,nneed);
    pullup(tree[node],tree[2*node],tree[2*node+1]);
}
V Query(int node,int l,int r,int ql,int qr)
{
    push_lazy(node,l,r);
    if(l>qr or r<ql)
    {
        V invali;
        invali.cap=-1;
        return invali;
    }
    if(ql<=l && r<=qr)
    {
        return tree[node];
    }
    int mid=(l+r)/2;
    V ans;
    pullup(ans,Query(2*node,l,mid,ql,qr),Query(2*node+1,mid+1,r,ql,qr));
    return ans;
}
int N;
bool isValid(int l, int r)
{
    auto ans=Query(1,1,N,l+1,r+1);
    long long need1=Query(1,1,N,l+1,l+1).need;
    long long le=ans.maxpref,re=ans.minpref;
    long long allneed=ans.need,allcap=ans.cap;
    if(le<=re && re+need1>=0 && allneed<=allcap)return 1;
    return 0;
}
void update(int l, int r, int x, int y)
{
    Update(1,1,N,l+1,r+1,y,x);
}
void init(std::vector<int> kids, const std::vector<int>candies)
{
    N=kids.size();
    for(int i=1;i<=N;i++)
    {
        Update(1,1,N,i,i,candies[i-1],kids[i-1]);
    }
}
