#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <random>
#include <unordered_map>
#include <tuple>
//std::vector<bool> cmpo[10001][10001];
//std::vector<std::vector<int>> pointSort(int n, int k){}
static void myAssert(bool cond, const std::string& msg)
{
    if (cond) return;

    std::cerr << msg << std::endl;

    exit(0);
}

static std::mt19937 generator;

static int n, k;
static std::vector<std::vector<int>> points;

static void initPoints()
{
    points.clear();
    points.resize(n);
    std::vector<int> perm(n);
    std::iota(perm.begin(), perm.end(), 0);
    for (int d = 0; d < k; ++d)
    {
        std::shuffle(perm.begin(), perm.end(), generator);
        for (int i = 0; i < n; ++i)
        {
            points[i].push_back(perm[i]);
        }
    }
}

static void inputPoints()
{
    points.clear();
    points.resize(n);
    for (int i = 0; i < n; ++i)
    {
        points[i].resize(k);
        for (int d = 0; d < k; ++d)
        {
            std::cin >> points[i][d];
        }
    }
}

static long long numCmps = 0;

std::vector<bool> compare(int i, int j)
{
    myAssert(i >= 0 && i < n && j >= 0 && j < n && i != j, "Invalid comparison");

    numCmps++;

    std::vector<bool> ans(k);
    for (int d = 0; d < k; d++)
    {
        ans[d] = points[i][d] < points[j][d];
    }
    return ans;
}

void printPoints(const std::vector<std::vector<int>>& points)
{
    for (int i = 0; i < (int) points.size(); i++)
    {
        if (i > 0) std::cerr << " ";
        std::cerr << "(";
        for (int d = 0; d < k; d++)
        {
            if (d > 0) std::cerr << " ";
            std::cerr << points[i][d];
        }
        std::cerr << ")";
    }
    std::cerr << std::endl;
}
int u;
std::unordered_map<int,bool> po[10001][5];
bool cmp(int i, int j)
{
    if(po[i][u].find(j)!=po[i][u].end())
    {
        po[j][u][i]=!po[i][u][j];
        return po[i][u][j];
    }
    std::vector<bool> y=compare(i,j);
    for(int d=0; d<y.size(); d++)
    {
        po[i][d][j]=y[d];
        po[j][d][i]=!y[d];
        for(int t=0; t<n; t++)
        {
            if( po[j][d].find(t)!=po[j][d].end())
            {
                if(po[i][d][j]  && po[j][d][t])
                {
                    po[i][d][t]=true;
                }
                if(!po[i][d][j]  && !po[j][d][t])
                {
                    po[i][d][t]=false;
                }
            }
//            if( po[i][d].find(t)!=po[i][d].end())
//            {
//                if(po[j][d][i]  && po[i][d][t])
//                {
//                    po[j][d][t]=true;
//                }
//                if(!po[j][d][i]  && !po[i][d][t])
//                {
//                    po[j][d][t]=false;
//                }
            }
        }

    }
    return po[i][u][j];

}
std::vector<std::vector<int>> pointSort(int n, int k)
{
    // std::cout<<"fucked";
    for(int i=0; i<n; i++)
    {
        for(int d=0; d<k; d++)
        {
            po[i][d].clear();
        }
    }
    std::vector<std::vector<int>> ans;
    for(int d=0; d<k; d++)
    {
        ans.push_back({});
        //  std::cout<<"dasda";
        for(int i=0; i<n; i++)
        {
            // std::cout<<2;
            //  std::cout<<d*n<<"\n";
            ans[d].push_back(i);


        }
    }
    u=0;
    for(int d=0; d<k; d++)
    {
        // ans.push_back({});
        //  std::cout<<"dasda";
        std::sort(ans[d].begin(),ans[d].end(),cmp);
        u++;
    }
    std::vector<std::vector<int>> ans2;
    for(int i=0; i<n; i++)
    {
        ans2.push_back({});
    }
    for(int d=0; d<k; d++)
    {
        for(int i=0; i<n; i++)
        {
            ans2[ans[d][i]].push_back(i);
        }
    }
    return ans2;
}
int main()
{
    int t;
    std::cin >> t;

    bool gen;
    std::cin >> n >> k >> gen;

    for (int i = 0; i < t; i++)
    {
        if (gen)
        {
            std::cout<<"huhu";
            int seed;
            seed=i*i-n;
            generator.seed(seed);

            initPoints();
        }
        else
        {
            inputPoints();
        }

        std::vector<std::vector<int>> pointsGuess = pointSort(n, k);
        std::cout<<"\n\n";
        printPoints(pointsGuess);
        std::cout<<"\n\n";
        printPoints(points);
        myAssert(pointsGuess == points, "Wrong answer");
    }

    std::cout << (double) numCmps / t << std::endl;

    return 0;
}
