#include <bits/stdc++.h>
#include "candies.h"

#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

#define endl '\n'

using namespace std;

const int MAXN = 2e5+50;
class SegmentTree
{

private:
    int N;

    int64_t normal_tree[MAXN];
    int64_t shifted_tree[MAXN];
    int64_t tree[MAXN];
    int64_t negatives[4*MAXN];

    void Recalculate(int node)
    {
        negatives[node] = negatives[2*node] + negatives[2*node+1];
    }


    void BuildInternal(const vector <int>& arr1, const vector <int>& arr2, int node, int L, int R)
    {
        if (L == R)
        {
            normal_tree[L] = arr2[L] - arr1[L];
            shifted_tree[L] = arr2[(L-1+N)%N] - arr1[(L-1+N)%N];
            tree[L] = (normal_tree[L] + shifted_tree[L]);

            negatives[node] = (tree[L]<0);

            cout << node << " " << L << " " << tree[L] << endl;
            return;
        }

        BuildInternal(arr1, arr2, node*2, L, (L+R)/2);
        BuildInternal(arr1, arr2, node*2+1, (L+R)/2+1, R);

        Recalculate(node);
    }

    void UpdateInternal(const int qPos, const int value, int node, int L, int R)
    {
        if (L > qPos || R < qPos)
            return;

        if (L == R)
        {
            negatives[node] = value;
            return;
        }

        UpdateInternal(qPos, value, node*2, L, (L+R)/2);
        UpdateInternal(qPos, value, node*2+1, (L+R)/2+1, R);

        Recalculate(node);
    }

    int64_t QueryInternal(const int queryL, const int queryR, int node, int L, int R)
    {
        if (L > queryR || R < queryL)
            return 0;

        if (L >= queryL && R <= queryR)
            return negatives[node];

        return QueryInternal(queryL, queryR, node*2, L, (L+R)/2) +
                QueryInternal(queryL, queryR, node*2+1, (L+R)/2+1, R);
    }

public:

    void Build(const int N, const vector <int>& arr1, const vector <int>& arr2)
    {
        this->N = N;
        BuildInternal(arr1, arr2, 1, 0, N-1);
    }

    void Update(int queryLeft, int queryRight, int value)
    {
        for (int pos = queryLeft; pos <= queryRight; pos++)
        {
            normal_tree[pos] = value;
            shifted_tree[(pos+1)%N] = value;

            tree[pos] = normal_tree[pos]+shifted_tree[pos];


            UpdateInternal(pos, tree[pos]<0, 1, 0, N-1);
        }

        /*cout << "Updated" << endl;
        for (int pos = 0; pos < N; pos++)
        {
            cout << tree[pos] << " ";
        }cout << endl;*/
    }

    int64_t Query(int queryLeft, int queryRight)
    {
        int valLeft = (tree[queryLeft] - shifted_tree[queryLeft] + normal_tree[queryRight])<0;
        int change = valLeft - (tree[queryLeft] < 0);
        return QueryInternal(queryLeft, queryRight, 1, 0, N-1) + change;

    }
};

SegmentTree tree;
void init(std::vector<int> kids, const std::vector<int> candies)
{
    tree.Build(kids.size(), kids, candies);
}
bool isValid(int l, int r)
{
    int64_t negatives = tree.Query(l, r);

    //cout << "Negatives: " << negatives << endl;
    return (negatives <= 0);
}
void update(int l, int r, int x, int y)
{
    tree.Update(l, r, y-x);
}

/*
5
2 0 9 4 1
0 5 4 6 7
7
2 4 4 8 1
1 0 1
2 3 3 4 9
2 1 2 2 2
1 3 4
1 2 2
1 2 4
*/
