#include "candies.h"
#include <vector>
using namespace std;

struct node{
    int data, data2, lazy1, lazy2;
    bool fl;
    node() : data(0), data2(0), lazy1(0), lazy2(0) {}
};

const int maxn = 1 + 2e5;
node tree[4*maxn];
vector<int>a,b;

void merge(int v, int l, int r){
    tree[v].fl = tree[v*2].fl & tree[v*2+1].fl;
}

void push(int v, int l, int r){
    if(tree[v].lazy1 || tree[v].lazy2){
        tree[v].fl = (tree[v].lazy1 <= tree[v].lazy2;
        if(l!=r){
            tree[v*2].lazy1 = tree[v*2+1].lazy1 = tree[v].lazy1;
            tree[v*2].lazy2 = tree[v*2+1].lazy2 = tree[v].lazy2;
        }
        tree[v].lazy1 = tree[v].lazy2 = 0;
    }
}

void build(int v, int l, int r){
    if(l == r){
        tree[v].data = a[l];
        tree[v].data2 = b[l];
        tree[v].fl = (a[l] <= b[l]);
        return;
    }
    int mid = (l+r)/2;
    build(v*2,l,mid);
    build(v*2+1,mid+1,r);
    merge(v,l,r);
}

void upd(int v, int l, int r, int ul, int ur, int dx, int dy){
    push(v,l,r);

    if(l > ur || r < ul)
        return;
    if(l>=ul && r <=ur)
    {
        tree[v].lazy1 = dx;
        tree[v].lazy2 = dy;
        push(v,l,r);
        return;
    }


    int mid = (l+r)/2;
    upd(v*2,l,mid,ul,ur,dx,dy);
    upd(v*2+1,mid+1,r,ul,ur,dx,dy);
    merge(v,l,r);
}

bool query(int v, int l, int r, int ql, int qr)
{
    if(l>qr || r < ql)
        return true;
    if(l>=ql && r<=qr)
        return tree[v].fl;

    int mid = (l+r)/2;
    return query(v*2,l,mid,ql,qr) & query(v*2+1,mid+1,r,ql,qr);
}

void init(vector<int> kids, const vector<int> candies){
    a= kids,b = candies;
    a.insert(begin(a),0);
    b.insert(begin(b),0);

    build(1,1,a.size()-1);

}

bool isValid(int l, int r) {return query(1,1,a.size()-1,l,r);}
void update(int l, int r, int x, int y){ upd(1,1,a.size()-1,l,r,x,y);}
