# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXM = 1e5 + 1;
const int MAXN = 101;
int N, M;
map<pair<int, int>, int> dp;
int PreCalc[MAXN][MAXN];
vector<int> Graph[MAXM + MAXN + 1];

void Dfs(int U)
{
    for(auto& Bridge : Graph[U])
    {
        for(auto& V : Graph[Bridge])
        {
            PreCalc[U][V] += (Bridge - MAXM);
        }
    }
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    if(N > 100)
    {
        for(int i = 0; i < M; i++)
        {
            int Size;
            cin >> Size;
            vector<int> A;

            for(int j = 0; j < Size; j++)
            {
                int Value;
                cin >> Value;
                A.push_back(Value);
            }

            for(int j = 0; j < Size; j++)
            {
                for(int k = 0; k < Size; k++)
                {
                    dp[ {A[j], A[k]}] += (i + 1);
                }
            }
        }
    }
    else
    {
        for(int i = 0; i < M; i++)
        {
            int Size;
            cin >> Size;

            for(int j = 0; j < Size; j++)
            {
                int Value;
                cin >> Value;
                Graph[i + 1 + MAXM].push_back(Value);
                Graph[Value].push_back(i + 1 + MAXM);
            }
        }

        for(int U = 1; U <= N; U++) Dfs(U);
    }



}

void Solve()
{
    int Q;
    cin >> Q;

    if(N > 100)
    {
        while(Q--)
        {
            int X, Y;
            cin >> X >> Y;
            int Answer = 0;
            Answer = dp[ {X, Y}];
            if(X == Y) Answer /= 2;
            cout << Answer << '\n';
        }
    }
    else
    {
        while(Q--)
        {
            int X, Y;
            cin >> X >> Y;
            int Answer = PreCalc[X][Y];
            if(X == Y) Answer /= 2;
            cout << Answer << '\n';
        }
    }


}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
