# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXM = 1e5 + 1;
const int MAXN = 101;
int N, M;
unordered_set<int> A[2 * MAXM + 1];
int PreCalc[MAXN][MAXN];
vector<int> Graph[2 * MAXM + 1];

void Dfs(int U)
{
    for(auto& Bridge : Graph[U])
    {
        for(auto& V : Graph[Bridge])
        {
            PreCalc[U][V] += (Bridge - MAXM);
        }
    }
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;


    for(int i = 0; i < M; i++)
    {
        int Size;
        cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int Value;
            cin >> Value;
            A[i + 1 + MAXM].insert(Value);
            Graph[i + 1 + MAXM].push_back(Value);
            Graph[Value].push_back(i + 1 + MAXM);
        }
    }

    if(N <= 100) for(int U = 1; U <= N; U++) Dfs(U);
}

void Solve()
{
    int Q;
    cin >> Q;

    if(N > 100)
    {
        while(Q--)
        {
            int X, Y;
            cin >> X >> Y;
            int Answer = 0;

            for(auto& V : Graph[X])
            {
                if((int)A[V].size() == 1 && *A[V].begin() == Y || A[V].find(Y) != A[V].end())
                {
                    Answer += (V - MAXM);
                }
            }

            cout << Answer << '\n';
        }
    }
    else
    {
        while(Q--)
        {
            int X, Y;
            cin >> X >> Y;
            int Answer = PreCalc[X][Y];
            if(X == Y) Answer /= 2;
            cout << Answer << '\n';
        }
    }


}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}