# define _GLIBCXX_FILESYSTEM
# include "candies.h"
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
int N;
ll A[MAXN];
ll B[MAXN];

void init(vector<int> Kids, vector<int> Candies)
{
    N = (int)Kids.size();
    for(int i = 0; i < N; i++) A[i] = Kids[i];
    for(int i = 0; i < N; i++) B[i] = Candies[i];
}


bool isValid(int l, int r)
{
    vector<int> Give(N + 1);
    vector<int> QueryA(N + 1);
    vector<int> QueryB(N + 1);
    priority_queue<tuple<int, int, int>> Pq;
    ll Size = (r - l + 1);

    for(ll i = 0; i < Size; i++)
    {
        QueryA[i] = A[i + l];
        QueryB[i] = B[i + l];
    }

    for(ll i = 0; i < Size; i++)
    {
        Give[i] = QueryA[i];
        Give[i] += QueryA[(i + 1) % Size];
        Pq.push({QueryA[i], i, (i - 1 + Size) % Size});
    }


    while(!Pq.empty())
    {
        auto[Value, i, j] = Pq.top();
        Pq.pop();
        if(Value == 0) continue;

        if(QueryB[i] + QueryB[j] < Value) return false;

        if(QueryB[i] > QueryB[j] || QueryB[i] == QueryB[j] && Give[i] > Give[j])
        {
            Give[i]--;
            Give[j]--;
            QueryB[i]--;
            Value--;
            Pq.push({Value, i, j});
        }
        else
        {
            Give[i]--;
            Give[j]--;
            QueryB[j]--;
            Value--;
            Pq.push({Value, i, j});
        }
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        A[i] = x;
        B[i] = y;
    }
}
