#include "pointsort.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e4+5;

int N;
vector<vector<int> >p;
int a[MAXN],b[MAXN];
map<pair<int,int> , vector<bool > > mymap;

vector<bool>get(int i, int j)
{
    int br = 0;
    if(i > j)
    {
        br = 1;
        swap(i,j);
    }

    if(mymap.find({i,j}) == mymap.end())
    {
        mymap[{i,j}] = compare(i,j);
    }
    if(br)
    {
        vector<bool>pom;
        pom = mymap[{i,j}];
        for(int z = 0; z < pom.size(); z++) pom[z] = 1-pom[z];
        return pom;
    }
    return mymap[{i,j}];
}

void Merge_sort(int l, int r, int d)
{
    if(l >= r) return;

    int mid = (l+r)/2;

    Merge_sort(l,mid+0,d);
    Merge_sort(mid+1,r,d);

    int pl = l;
    int pr = mid+1;
    int p = l;

    /*cout << endl;
    cout << endl;
    cout << l << " " << r << endl;
    for(int i = l; i <= r; i++) cout << a[i] << " ";
    cout << endl;*/

    while(pl <= mid && pr <= r)
    {
        vector<bool>pom = get(a[pl],a[pr]);
        if(pom[d]) b[p] = a[pl++];
        else b[p] = a[pr++];

        p++;
    }


    while(pl <= mid)
    {
        b[p] = a[pl++];
        p++;
    }
    while(pr <= r)
    {
        b[p] = a[pr++];
        p++;
    }
    for(int i = l; i <= r; i++) a[i] = b[i];


    /*cout << "after merge" << endl;
    for(int i = l; i <= r; i++) cout << a[i] << " ";
    cout << endl;*/


}

vector<int>g[MAXN];
vector<int>ans;
int used[MAXN];

void dfs(int beg)
{
    used[beg] = 1;
    for(int nb : g[beg])
    {
        if(!used[nb]) dfs(nb);
    }
    ans.push_back(beg);
}

void top_sort(int d)
{
    ans.clear();
    for(int i = 0; i < N; i++) used[i] = 0;
    for(int i = 0; i < N; i++) g[i].clear();

    for(auto it = mymap.begin(); it != mymap.end(); it++)
    {
        pair<int,int> chis = (it->first);
        vector<bool> v = (it->second);
        if(v[d]) g[chis.first].push_back(chis.second);
        else g[chis.second].push_back(chis.first);
    }

    for(int i = 0; i < N; i++)
    {
        if(!used[i]) dfs(i);
    }
    //reverse(ans.begin(),ans.end());
}


std::vector<std::vector<int>> pointSort(int n, int k)
{
    N = n;
    mymap.clear();
    p.clear();
    p.resize(N);
    for(int i = 0; i < N; i++) g[i].clear();

    for(int i = 0; i < N; i++) p[i].resize(k);

    vector<int>q;
    for(int i = 0; i < N; i++) q.push_back(i);

    for(int j = 0; j < k; j++)
    {
        ///top_sort(j);
        /*for(int i = 0; i < N; i++) cout << ans[i] << " ";
        cout << endl << "endans" << endl;*/
        for(int i = 0; i < N; i++) a[i] = q[i];
        random_shuffle(q.begin(),q.end());

        Merge_sort(0,N-1,j);

        for(int i = 0; i < N; i++) p[a[i]][j] = i;

        /*for(int i = 0; i < N; i++) cout << p[i][j] << " ";
        cout << endl;*/
    }
    return p;
}
