#include "pointsort.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

const int maxn = 10005;
int best[maxn][5];
int coords[maxn][5];

map<pair<int, int>, vector<bool>> results;

vector<bool> myCompare(int x, int y)
{
    //cout << "here " << x << " " << y << endl;
    if (results.find({x, y}) != results.end()) return results[{x, y}];
    return results[{x, y}] = compare(x, y);
}

void mergeSort(int l, int r, int dim)
{
    if (l == r) return;

    int mid = (l + r) / 2;
    mergeSort(l, mid, dim);
    mergeSort(mid + 1, r, dim);

    vector<int> sortedOrder;
    int lPtr = l, rPtr = mid + 1;

    while (lPtr != mid + 1 || rPtr != r + 1)
    {
        if (lPtr == mid + 1)
        {
            sortedOrder.push_back(best[rPtr++][dim]);
        }
        else if (rPtr == r + 1)
        {
            sortedOrder.push_back(best[lPtr++][dim]);
        }
        else
        {
            vector<bool> result = myCompare(best[lPtr][dim], best[rPtr][dim]);
            if (result[dim] == true) sortedOrder.push_back(best[lPtr++][dim]);
            else sortedOrder.push_back(best[rPtr++][dim]);
        }
    }

    for (int i = l; i <= r; ++i)
    {
        best[i][dim] = sortedOrder[i - l];
    }
}

vector<vector<int>> pointSort(int n, int k)
{
    results.clear();
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            best[i][j] = i;
        }
    }

    for (int i = 0; i < k; ++i)
    {
        mergeSort(0, n - 1, i);

        for (int j = 0; j < n; ++j)
        {
            coords[best[j][i]][i] = j;
        }
    }

    vector<vector<int>> ans;

    for (int i = 0; i < n; ++i)
    {
        ans.push_back({});

        for (int j = 0; j < k; ++j)
        {
            ans.back().push_back(coords[i][j]);
            //cout << ans[i][j] << "";
        }

        //cout << endl;
    }

    return ans;
}
