#include <iostream>
#include <vector>
#include "candies.h"

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn], curra[maxn], currb[maxn];;
int delta[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    for (int i = l; i <= r; ++i)
    {
        curra[i] = a[i];
        currb[i] = b[i];
        delta[i] = b[i] - a[i];
    }

    delta[l] += max(b[r], delta[r]);
    if (delta[l] < 0) return false;

    for (int i = l + 1; i <= r; ++i)
    {
        delta[i] += min(delta[i - 1], b[i - 1]);
        if (delta[i] < 0) return false;
    }
//cout << "now " << delta[l] << " " << delta[r] << endl;

    return true;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
