#include <bits/stdc++.h>
///#include "Lgrader.cpp"
#include "candies.h"

using ll = long long;
using namespace std;

struct Node
{
    ll a, b;
    ll lazya, lazyb;
};

vector <int> v1, v2;
int sz;

Node operator + (Node l, Node r)
{
    Node ret;

    ret.a = l.a + r.a;
    ret.b = l.b + r.b;
    ret.lazya = ret.lazyb = 0;

    return ret;
}

struct BranchManager
{
    Node tree[800005];

    void build(int node, int l, int r)
    {
        if (l == r)
        {
            tree[node].a = v1[l];
            tree[node].b = v2[l];

            return;
        }

        int mid = l + r >> 1;

        build(2 * node, l, mid);
        build(2 * node + 1, mid + 1, r);

        tree[node] = tree[2 * node] + tree[2 * node + 1];
    }

    void push(int node, int l, int r)
    {
        if (tree[node].lazya == 0 && tree[node].lazyb == 0)
        {
            return;
        }

        if (l != r)
        {
            tree[2 * node].lazya = tree[2 * node].a = tree[node].lazya;
            tree[2 * node].lazyb = tree[2 * node].b = tree[node].lazyb;

            tree[2 * node + 1].lazya = tree[2 * node + 1].a = tree[node].lazya;
            tree[2 * node + 1].lazyb = tree[2 * node + 1].b = tree[node].lazyb;
        }

        tree[node].lazya = tree[node].lazyb = 0;
    }

    void update(int node, int l, int r, int ql, int qr, ll val1, ll val2)
    {
        if (l > qr || r < ql)
        {
            return;
        }

        if (ql <= l && r <= qr)
        {
            tree[node].lazya = val1;
            tree[node].lazyb = val2;
            tree[node].a = val1;
            tree[node].b = val2;

            return;
        }

        push(node, l, r);

        int mid = l + r >> 1;

        update(2 * node, l, mid, ql, qr, val1, val2);
        update(2 * node + 1, mid + 1, r, ql, qr, val1, val2);

        tree[node] = tree[2 * node] + tree[2 * node + 1];
    }

    Node query(int node, int l, int r, int ql, int qr)
    {
        if (l > qr || r < ql)
        {
            return {0LL, 0LL, 0LL, 0LL};
        }

        if (ql <= l && r <= qr)
        {
            return tree[node];
        }

        push(node, l, r);

        int mid = l + r >> 1;

        return query(2 * node, l, mid, ql, qr) + query(2 * node + 1, mid + 1, r, ql, qr);
    }
};

BranchManager st;

void init(std::vector<int> kids, const std::vector<int> candies)
{
    ///v1 = kids;
    ///v2 = candies;

    for (int i = 0; i < kids.size(); i++)
    {
        v1.push_back((ll)(kids[i]));
    }

    for (int i = 0; i < candies.size(); i++)
    {
        v2.push_back((ll)(candies[i]));
    }

    st.build(1, 0, kids.size() - 1);
    sz = kids.size() - 1;

    ///Node ret = st.query(1, 0, sz)
}

bool isValid(int l, int r)
{
    Node ret = st.query(1, 0, sz, l, r);

    ///cout << "ret: " << ret.a << " " << ret.b << endl;

    if (ret.a <= ret.b)
    {
        return 1;
    }

    return 0;
}

void update(int l, int r, int x, int y)
{
    ll nx = (ll)(x);
    ll ny = (ll)(y);

    st.update(1, 0, sz, l, r, nx, ny);
}
