#include<bits/stdc++.h>

using namespace std;

typedef unsigned long long ll;

const ll MAXN = 1e5 + 10;
const ll MAXM = 1e5 + 10;

ll n, m, q;

vector < ll > kosh[MAXM];

vector < pair < pair < ll, ll >, ll > > db;
vector < ll > in[MAXN];
vector < ll > pref;

bitset < MAXN > imago[MAXM];

ll maxk;


ll ans[1010][1010];

void read()
{
    cin >> n >> m;

    for(ll i = 1; i <= m; i++)
    {
        ll k;
        cin >> k;

        maxk = max(maxk, k);

        for(ll j = 1; j <= k; j++)
        {
            ll mush;
            cin >> mush;
            kosh[i].push_back(mush);
            in[mush].push_back(i);
            imago[i].set(mush);
        }
    }
}

void solve1()
{
    for(ll i = 1; i <= n; i++)
    {
        ll sz = in[i].size();

        for(ll j = 0; j < sz; j++)
        {
            for(ll x : kosh[in[i][j]])
            {
                ans[i][x] += in[i][j];
            }
        }
    }
}

bool cmp(pair < pair < ll, ll >, ll > p1, pair < pair < ll, ll >, ll > p2)
{
    if(p1.first.first < p2.first.first)
        return true;

    if(p1.first.first > p2.first.first)
        return false;

    if(p1.first.second < p2.first.second)
        return true;

    if(p1.first.second > p2.first.second)
        return false;

    if(p1.second < p2.second)
        return true;

    return false;
}

void solve2()
{
    for(ll i = 1; i <= m; i++)
    {
        ll sz = kosh[i].size();

        for(ll j = 0; j < sz; j++)
        {
            for(ll k = j + 1; k < sz; k++)
            {
                ll x = kosh[i][j];
                ll y = kosh[i][k];

                if(x > y)
                    swap(x, y);

                db.push_back({{x, y}, (ll)i});
            }
        }
    }

    sort(db.begin(), db.end(), cmp);

    /*


    for(pair < pair < ll, ll >, ll > p : db)
    {
        cout << p.first.first << "-" << p.first.second << " in " << p.second << endl;
    }
    */


    ll sz = db.size();

    pref.resize(sz);

    pref[0] = db[0].second;

    for(ll i = 1; i < sz; i++)
    {
        pref[i] = pref[i - 1] + db[i].second;
    }
}

bool check1(pair < pair < ll, ll >, ll > p, ll a, ll b)
{
    if(p.first.first > a)
        return true;

    if(p.first.first == a && p.first.second >= b)
        return true;

    return false;
}

bool check2(pair < pair < ll, ll >, ll > p, ll a, ll b)
{
    if(p.first.first < a)
        return true;

    if(p.first.first == a && p.first.second <= b)
        return true;

    return false;
}

ll find_left(ll a, ll b)
{
    ll left = -1;
    ll right = db.size();
    ll mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;

        pair < pair < ll, ll >, ll > cur = db[mid];

        if(check1(cur, a, b))
            right = mid;
        else
            left = mid;
    }

    return right;
}

ll find_right(ll a, ll b)
{
    ll left = -1;
    ll right = db.size();
    ll mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;

        pair < pair < ll, ll >, ll > cur = db[mid];

        if(check2(cur, a, b))
            left = mid;
        else
            right = mid;
    }

    return left;
}

ll query(ll a, ll b)
{
    if(m <= 100 || maxk <= 100)
    {
        ll result = 0;

        for(int x : in[a])
        {
            if(imago[x][b])
                result += x;
        }

        return result;
    }

    if(n <= 1000)
    {
        return ans[a][b];
    }

    ll left = find_left(a, b);
    ll right = find_right(a, b);

    //cout << "FOUND LEFT : " << left << endl;
    //cout << "FOUND RIGHT : " << right << endl;

    if(left == -1 || right == db.size() || left == db.size() || right == -1)
        return 0LL;

    if(db[left].first.first != a || db[left].first.second != b || db[right].first.first != a || db[right].first.second != b)
        return 0LL;

    if(left == 0)
        return pref[right];

    return pref[right] - pref[left - 1];
}

void process_queries()
{
    cin >> q;

    for(ll i = 1; i <= q; i++)
    {
        ll a, b;
        cin >> a >> b;

        if(a > b)
            swap(a, b);

        //cout << "Query : " << i << endl;

        cout << query(a, b) << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();


    if(n <= 1000)
        solve1();

    solve2();

    process_queries();
    return 0;
}
