#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXM = 1e5 + 10;

int n, m, q;

vector < int > kosh[MAXM];

vector < pair < pair < int, int >, ll > > db;
vector < ll > pref;

void read()
{
    cin >> n >> m;

    for(int i = 1; i <= m; i++)
    {
        int k;
        cin >> k;

        for(int j = 1; j <= k; j++)
        {
            int mush;
            cin >> mush;
            kosh[i].push_back(mush);
        }
    }
}

void solve()
{
    for(int i = 1; i <= m; i++)
    {
        int sz = kosh[i].size();

        for(int j = 0; j < sz; j++)
        {
            for(int k = j + 1; k < sz; k++)
            {
                int x = kosh[i][j];
                int y = kosh[i][k];

                if(x > y)
                    swap(x, y);

                db.push_back({{x, y}, i});
            }
        }
    }

    sort(db.begin(), db.end());

    int sz = db.size();

    pref.resize(sz);

    pref[0] = db[0].second;

    for(int i = 1; i < sz; i++)
    {
        pref[i] = pref[i - 1] + db[i].second;
    }
}

bool check1(pair < pair < int, int >, ll > p, int a, int b)
{
    if(p.first.first > a)
        return true;

    if(p.first.first == a && p.first.second >= b)
        return true;

    return false;
}

bool check2(pair < pair < int, int >, ll > p, int a, int b)
{
    if(p.first.first < a)
        return true;

    if(p.first.first == a && p.first.second <= b)
        return true;

    return false;
}

int find_left(int a, int b)
{
    int left = -1;
    int right = db.size();
    int mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;

        pair < pair < int, int >, ll > cur = db[mid];

        if(check1(cur, a, b))
            right = mid;
        else
            left = mid;
    }

    return right;
}

int find_right(int a, int b)
{
    int left = -1;
    int right = db.size();
    int mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;

        pair < pair < int, int >, int > cur = db[mid];

        if(check2(cur, a, b))
            left = mid;
        else
            right = mid;
    }

    return left;
}

ll query(int a, int b)
{
    int left = find_left(a, b);
    int right = find_right(a, b);

    if(left == 0)
        return pref[right];

    return pref[right] - pref[left - 1];
}

void process_queries()
{
    cin >> q;

    for(int i = 1; i <= q; i++)
    {
        int a, b;
        cin >> a >> b;

        cout << query(a, b) << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
    process_queries();
    return 0;
}
